<?php
  //Parent file, set access flag
  define('_ACCESS_', 1);
  
	/**
	 * <!-- elSQL - e-learn SQL -->
	 * 
   * \par Main admin working site
   * \file
   *
   * Administrator panel. Allows to edit and delete user, resetting databases
   * and configure the environment variables of the installation.
   *
   * \author Stephan Schuetz, stephan.schuetz(at)fhnw.ch
   * \date 14.10.2007
   * \version 1.0
   *
   * (c) Copyright GITTA 2007. Creative Commons License "Attribution-Noncommercial-Share Alike"
	 *                           http://creativecommons.org/licenses/by-nc-sa/3.0/
   */
  
  session_start();

  @require_once('../conf/conf.inc.php');
  
  if(!isset($_SESSION['s_sUserID']) || ($_SESSION['s_sUserID'] != sha1($pConf['database']['user'].$pConf['database']['password'])))
    die('Administrator login required.');
  

  @require_once('../layout/layout.inc.php');
  @require_once('../language/language.inc.php');
  @require_once('../common/admin.class.php');
  
  $pAdmin = new admin();
  $bEditUser = false;
  $iResetSuccess = -1;
  
  if (isset($_GET['logout']))
  {
    session_unset();
    session_destroy();

    header('Location: ../index.php');
  }
  
  if (isset($_GET['act']) && isset($_GET['id']))
  {
    switch ($_GET['act'])
    {
      case "edius":
        $bEditUser = true;
        break;
      
      case "delus":
        $pAdmin->deleteUser($_GET['id']);
        break;
    }
  }
  
  if (isset($_POST['subact']))
  {
    switch ($_POST['subact'])
    {
      case "edius":
        $pAdmin->editUser();
        break;
      
      case "delu":
        $pAdmin->deleteUsers($_POST['seluser']);
        break;
      
      case "resdb":
        $iResetSuccess = $pAdmin->resetDB($_POST['seluser']);
        break;
    }
  }
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
<link rel="stylesheet" type="text/css" href="../layout/global.css"/>
<link rel="stylesheet" type="text/css" href="../layout/admin.css"/>
<script type="text/javascript" src="../lib/dojo/dojo.js"></script>
<script type="text/javascript">
<!--
  dojo.require("dojo.widget.TabContainer");
  dojo.require("dojo.widget.LinkPane");
  dojo.require("dojo.widget.ContentPane");
  dojo.require("dojo.io.*");
  dojo.require("dojo.json");

  function init()
  {
    var pFormSetEnv = new dojo.io.FormBind({
        formNode: document.forms.formEnv,
        load: handlerFormSetEnv});
    
    pFormSetEnv.onSubmit = handlerFormSetEnvSubmit;
    
    var pFormResDB = new dojo.io.FormBind({
        formNode: document.forms.formResDB,
        load: handlerFormStdReturn});
    
    pFormResDB.onSubmit = handlerFormResDBSubmit;
    
    <?php
      switch ($iResetSuccess)
      {
        case "1":
          echo "alert(\""._RESETDBSSUCCESS."\")";
          break;
        
        case "0":
          echo "alert(\""._ERRRESETDBS."\")";
          break;
        
        case "-1":
          break;
      }
    ?>
  }
    
  function handlerFormStdReturn(type, data, e)
  {
    var pData = dojo.json.evalJson(data);
    if (pData['ret'] == true)
    {
      alert(pData['mes']);
    }
    else
    {
      alert(pData['mes']);
    }
  }
  
  function handlerFormSetEnv(type, data, e)
  {
    var pData = dojo.json.evalJson(data);
    if (pData['ret'] == true)
    {
      alert(pData['mes']);
    }
    else
    {
      alert(pData['mes']);
    }
    
    dojo.byId("dbadminpwold").value = "";
    dojo.byId("dbadminpwnew").value = "";
    dojo.byId("dbadminpwnewvalid").value = "";
  }
  
  function handlerFormSetEnvSubmit()
  {
    return confirm("<?php echo _SETENVCONFIRM; ?>");
  }
  
  function handlerFormResDBSubmit()
  {
    return confirm("<?php echo _RESDBCONFIRM; ?>");
  }

  function confirmAction(sAction, sUser)
  {
    if(sAction == 'd')
    {
      return confirm("<?php echo _DELUSERCONFIRM; ?>" + sUser);
    }
    else
    {
      return confirm("<?php echo _EDITUSERCONFIRM; ?>" + sUser); 
    }
  }
  
  function selectAllUser()
  {
    var pCheckboxes = document.forms["formUserAdmin"].elements["seluser[]"];
    
    if (pCheckboxes)
    {
      var iLength = pCheckboxes.length;
      
      if (!iLength)
      {
        document.forms["formUserAdmin"].elements["seluser[]"].checked = true;
      }
      
      for(i = 0; i < iLength; i++)
      {
        pCheckboxes[i].checked = true;
      }
    }
  }
  
  function deselectAllUser()
  {
    var pCheckboxes = document.forms["formUserAdmin"].elements["seluser[]"];
    
    if (pCheckboxes)
    {
      var iLength = pCheckboxes.length;
      
      if (!iLength)
      {
        document.forms["formUserAdmin"].elements["seluser[]"].checked = false;
      }
      
      for(i = 0; i < iLength; i++)
      {
        pCheckboxes[i].checked = false;
      }
    }
  }
  
  function editUser()
  {
    dojo.byId("subact").value = "edius";
    
    document.forms.formUserAdmin.submit();
  }
  
  function deleteUser()
  {
    if (checkSelection())
    {
      dojo.byId("subact").value = "delu";
      
      if(confirm("<?php echo _DELUSERSCONFIRM; ?>"))
      {
        document.forms.formUserAdmin.submit();
      }
    }
  }
  
  function resetDB()
  {
    if (checkSelection())
    {
      dojo.byId("subact").value = "resdb";
      
      if(confirm("<?php echo _RESETDBSCONFIRM; ?>"))
      {
        document.forms.formUserAdmin.submit();
      }
    }
  }
  
  function checkSelection()
  {
    bSelection = false;
    
    var pCheckboxes = document.forms["formUserAdmin"].elements["seluser[]"];
    
    if(!pCheckboxes || !document.forms["formUserAdmin"].elements["seluser[]"].checked)
    {
      alert("<?php echo _NOSELECTION; ?>");

      return false;
    }
    
    var iLength = pCheckboxes.length;
    
    if (!iLength)
    {
      bSelection = document.forms["formUserAdmin"].elements["seluser[]"].checked;
    }
    else
    {
      for (i = 0; i < iLength; i++)
        bSelection = bSelection || pCheckboxes[i].checked; 
    }
      
    if (!bSelection)
      alert("<?php echo _NOSELECTION; ?>");
    
    return bSelection;
  }
  
  function generatePW()
  {
    var sNumberChars = "0123456789";
    var sLowerChars = "abcdefghijklmnopqrstuvwxyz";
    var sUpperChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    
    var sCharSet = sNumberChars + sLowerChars + sUpperChars;
    var sCharSetLength = sCharSet.length;
    
    var sPW = "";
    
    for(i = 0; i < 10; i++)
    {
      sPW = sPW + sCharSet.charAt(Math.floor(Math.random() * sCharSetLength));
    }
    dojo.byId("pw").value = sPW;
    
    setEmail(sPW);
  }
  
  dojo.addOnLoad(init);
-->
</script>
<?php $pLayout->printTitle(_ADMINTITLE); ?>
</head>
<body>
<div class="logout"><?php echo _ADMIN ?> <a href="admin.php?logout=true&"><?php echo _LOGOUT; ?></a></div>
<h1><?php echo "elSQL - ".$pConf['info']['title']."<br />"._ADMINTITLE ?></h1>
<div id="mainTabContainer" dojoType="TabContainer" selectedTab="tab1" style="width: 100%; height: 83%;">
  
  <div id="tab1" dojoType="ContentPane" label="<?php echo _USERADMIN; ?>" style="overflow:auto;">
    <div class="insideTab">
      <div dojoType="LayoutContainer">
        <div dojoType="ContentPane">
          <?php
            if ($bEditUser)
            {
              $pAdmin->showEditUserTitle();
            }
            else
            {
              $pAdmin->showUserTableTitle();
            }
          ?>         
        </div>
        <div dojoType="ContentPane" style="overflow:auto; height:100%">
          <form method="post" action="admin.php" id="formUserAdmin">
            <input type="hidden" value="NULL" id="subact" name="subact"/>
            <?php
              if ($bEditUser)
              {
                $pAdmin->showEditUser($_GET['id']);
              }
              else
              {
                $pAdmin->showUserTable();
              }
            ?>
          </form>
        </div>
      </div>
    </div>
  </div>

  <div id="tab2" dojoType="ContentPane" label="<?php echo _DATABASE; ?>" style="overflow:auto;">
    <div class="insideTab">
      <h3><?php echo _RESETALLDB; ?></h3>
      <form method="post" action="../common.php" id="formResDB">
        <input type="hidden" value="ardb" name="act"/>
        <input type="submit" value="<?php echo _RESETDB; ?>"/>
      </form>
    </div>
  </div>

  <div id="tab3" dojoType="ContentPane" label="<?php echo _ENVVARIABLES; ?>" style="overflow:auto;">
    <div class="insideTab">
      <form method="post" action="../common.php" id="formEnv">
        <input type="hidden" value="aupev" name="act"/>
        <br />
        <?php echo _ENVVARIABLESWARNING; ?><br />
        <br />
        <table>
          <tr>
            <td colspan="2">
              <h3><?php echo _DATABASEPARAMS; ?></h3>
            </td>
          </tr>
          <tr>
            <td><?php echo _SYSTEM; ?></td>
            <td>
              <select id="dbsystem" name="dbsystem" size="1">
                <option <?php ($pConf['database']['system'] == "pgsql") ? (print "selected=\"selected\"") : (print ""); ?> value="pgsql">PostgreSQL</option>
                <option <?php ($pConf['database']['system'] == "mysql") ? (print "selected=\"selected\"") : (print ""); ?> value="mysql">mySQL</option>
              </select>
            </td>
          </tr>
          <tr>
            <td><?php echo _HOST; ?></td>
            <td><input type="text" id="dbhost" name="dbhost" maxlength="30" value="<?php echo $pConf['database']['host']; ?>" readonly="readonly"/></td>
          </tr>
          <tr>
            <td><?php echo _PORT; ?></td>
            <td><input type="text" id="dbport" name="dbport" maxlength="5" value="<?php echo $pConf['database']['port']; ?>"/></td>
          </tr>
          <tr>
            <td><?php echo _INSTANCE; ?></td>
            <td><input type="text" id="dbinstance" name="dbinstance" maxlength="30" value="<?php echo $pConf['database']['name']; ?>"/></td>
          </tr>
          <tr>
            <td colspan="2">
              <br />
              <h3><?php echo _ELSQLPARAMS ?></h3>
            </td>
          </tr>
          <tr>
            <td><?php echo _ADMINUSER; ?></td>
            <td><input type="text" id="dbadminuser" name="dbadminuser" maxlength="16" value="<?php echo $pConf['database']['user']; ?>"/></td>
          </tr>
          <tr>
            <td><?php echo _ADMINPWOLD; ?></td>
            <td><input type="password" id="dbadminpwold" name="dbadminpwold" maxlength="30" value=""/></td>
          </tr>
          <tr>
            <td><?php echo _ADMINPWNEW; ?></td>
            <td><input type="password" id="dbadminpwnew" name="dbadminpwnew" maxlength="30" value=""/></td>
          </tr>
          <tr>
            <td><?php echo _ADMINPWNEWVALID; ?></td>
            <td><input type="password" id="dbadminpwnewvalid" name="dbadminpwnewvalid" maxlength="30" value=""/></td>
          </tr>
          <tr>
            <td><?php echo _UNIVERSITY; ?></td>
            <td><input type="text" id="title" name="title" maxlength="30" value="<?php echo $pConf['info']['title'] ?>"/></td>
          </tr>
          <tr>
            <td><?php echo _EMAILADMIN; ?></td>
            <td><input type="text" id="email" name="email" maxlength="30" value="<?php echo $pConf['info']['email']; ?>"/></td>
          </tr>
          <tr>
            <td><?php echo _LANGUAGE; ?></td>
            <td>
              <select id="language" name="language" size="1">
                <option <?php ($pConf['common']['language'] == "en") ? (print "selected=\"selected\"") : (print ""); ?> >en</option>
                <option <?php ($pConf['common']['language'] == "de") ? (print "selected=\"selected\"") : (print ""); ?> >de</option>
              </select>
            </td>
          </tr>
          <tr>
            <td><?php echo _DATA; ?></td>
            <td>
              <select id="datadir" name="datadir" size="1">
                <?php
                  $pDataDirs = scandir('../data');
                  
                  foreach ($pDataDirs as $sDir)
                  {
                    if(is_dir("../data/".$sDir) && $sDir != "." && $sDir != "..")
                    {
                      print "<option ".(($pConf['common']['datadir'] == $sDir) ? "selected=\"selected\"" : "")." >".$sDir."</option>\n";
                    }
                  }
                ?>
              </select>
            </td>
          </tr>
          <tr>
            <td><?php echo _MAXNUMRESULTS; ?></td>
            <td><input type="text" id="maxnumresults" name="maxnumresults" maxlength="30" value="<?php echo $pConf['common']['maxnumresult']; ?>"/></td>
          </tr>
          <tr>
            <td><?php echo _EMAILAVAILABLE; ?></td>
            <td>
              <select id="emailsupport" name="emailsupport" size="1">
                <option value="false" <?php ($pConf['common']['language'] == "false") ? (print "selected=\"selected\"") : (print ""); ?> >No</option>
                <option value="true" <?php ($pConf['common']['language'] == "true") ? (print "selected=\"selected\"") : (print ""); ?> >Yes</option>
              </select>
            </td>
          </tr>
          <tr>
            <td><?php echo _REGPW; ?></td>
            <td><input type="text" id="regpassword" name="regpassword" maxlength="30" value="<?php echo $pConf['common']['regpassword']; ?>"/></td>
          </tr>
        </table>
        <br />
        <input type="submit" value="<?php echo _UPDATEPARAMS; ?>"/>
      </form>
    </div>
  </div>

  <div id="tab4" dojoType="ContentPane" label="<?php echo _INFORMATION; ?>">
    <div class="insideTab">
    <?php
      echo _LICENSE;
      $pLayout->printFooter();
    ?>
    </div>
  </div>

</div>
</body>
</html>
<?php
  session_write_close();
?>