<?php
  //Parent file, set access flag
  define('_ACCESS_', 1);
	
	/**
	 * <!-- elSQL - e-learn SQL -->
   *
   * \par Handler for common commands
   * \file
   *
   * Calls different functions depending on the parameters:
   * - Changing user password
   * - Changing user information
   * - Resetting user database
   * - Setting environment variables, writing configuration file (administrator login required)
   * - Resetting all databasese (administrator login required)
   *
   * Returns JSON encoded data (array containing two elements: ret and mes).
   *
   * \author Stephan Schuetz, stephan.schuetz(at)fhnw.ch
   * \date 14.10.2007
   * \version 1.0
   *
   * (c) Copyright GITTA 2007. Creative Commons License "Attribution-Noncommercial-Share Alike"
	 *                           http://creativecommons.org/licenses/by-nc-sa/3.0/
   */
  
  session_start();
  
  if(!isset($_SESSION['s_sUserID']))
    die('Login required.');

  @require_once('./conf/conf.inc.php');
  @require_once('./language/language.inc.php');

  @require('./common/common.inc.php');

  $sAction= isset($_POST['act']) ? trim($_POST['act']) : '';

  switch($sAction)
  {
    case 'upwc':
      $pReturn = changeUserPW();
      break;
    
    case 'urdb':
      $pReturn = resetDB();
      break;
    
    case 'uuic':
      $pReturn = changeUserInfo();
      break;

    case 'aupev':
      if($_SESSION['s_sUserID'] != sha1($pConf['database']['user'].$pConf['database']['password']))
        die('Administrator login required.');
      
      $pReturn = setEnvVar();
      break;

    case 'ardb':
      if($_SESSION['s_sUserID'] != sha1($pConf['database']['user'].$pConf['database']['password']))
        die('Administrator login required.');
        
      $pReturn = resetAllDB();
      break;
  }
  
  echo json_encode($pReturn);
  
  session_write_close();
?>