<?php
  //No direct access
  defined('_ACCESS_') or die('Direct Access to this location is not allowed.');
  
	/**
	 * <!-- elSQL - e-learn SQL -->
   *
   * \class admin
   *
   * Offers functionality for admin.php.
   *
   * \author Stephan Schuetz, stephan.schuetz(at)fhnw.ch
   * \date 14.10.2007
   * \version 1.0
   *
   * (c) Copyright GITTA 2007. Creative Commons License "Attribution-Noncommercial-Share Alike"
	 *                           http://creativecommons.org/licenses/by-nc-sa/3.0/
   */

  class admin
  {
    /**
     * Constructor
     */
    public function __construct()
    {
    }

    /**
     * Destructor
     */
    public function __destruct()
    {
    }
    
    /**
     * Returns the HTML code for the buttons which are needed for user
     * administration.
     * \return Echo HTML code.
     */
    public function showUserTableTitle()
    {
      echo '<button type="button" id="selectAll" onclick="selectAllUser();">'._SELECTALLUSER.'</button> <button type="button" id="deselectAllUser" onclick="deselectAllUser();">'._DESELECTALLUSER.'</button> <button type="button" id="deleteUser" onclick="deleteUser();">'._DELETEUSER.'</button> <button type="button" id="resetDB" onclick="resetDB();">'._RESETDB.'</button>';
    }
 
    /**
     * Returns the HTML code to show the user information.
     * \return Echo HTML code.
     */
    public function showUserTable()
    {
      @require('../database/db.inc.php');
      
      echo '    <table class="useradmin">
                  <tr>
                    <th class="useradmin" colspan="3">'._EDIT.'</th>
                    <th class="useradmin">'._NAME.'</th>
                    <th class="useradmin">'._FIELDOFSTUDY2.'</th>
                    <th class="useradmin">'._EMAIL2.'</th>
                    <th class="useradmin">'._LASTLOGIN.'</th>
                  </tr>
                  ';
      
      $pDbCommands->buildUserTable($pDb);
      
      echo '          </table>';
    }
    
    /**
     * Returns the HTML code for title of the edit user site.
     * \return Echo HTML code.
     */
    function showEditUserTitle()
    {
      echo '<h3>'._EDITUSER.'</h3>';
    }
    
    /**
     * Returns the HTML code for the edit user form.
     * \return Echo HTML code.
     */
    public function showEditUser()
    {
      @require('../database/db.inc.php');
      
      $sID = $pDb->escapeString($_GET['id']);
      
      //Get the information of a specific user
      $pLoginData = $pDbCommands->getLoginDataById($pDb, $sID);
      
      echo '    <input type="hidden" name="id" value="'.$sID.'"/>
                <script type="text/javascript">'."<!-- function setEmail(sPW) { dojo.byId(\"emailpw\").href = \"mailto:".$pLoginData[5]."?subject="._EMAILUSERNEWPWSUBJECT."&body="._EMAILUSERNEWPW."\" + sPW; } -->".'</script>
                <table>
                  <tr>
                    <td>"._FNAME."</td>
                    <td><input type="text" name="firstname" maxlength="30" value="'.utf8_encode($pLoginData[2]).'"/></td>
                  </tr>
                  <tr>
                    <td>'._LNAME.'</td>
                    <td><input type="text" name="lastname" maxlength="30" value="'.utf8_encode($pLoginData[1]).'"/></td>
                  </tr>
                  <tr>
                    <td>'._FIELDOFSTUDY.'</td>
                    <td><input type="text" name="fieldofstudy" maxlength="30" value="'.utf8_encode($pLoginData[4]).'"/></td>
                  </tr>
                  <tr>
                    <td>'._EMAIL.'</td>
                    <td><input type="text" name="email" maxlength="30" value="'.$pLoginData[5].'" readonly="readonly"/></td>
                  </tr>
                  <tr>
                    <td>'._PASSWORD.'</td>
                    <td><input type="text" name="pw" id="pw" maxlength="30" readonly="readonly"/> <button type="button" id="generateNewPW" onclick="generatePW();">'._GENERATEPW.'</button></td>
                  </tr>
                  <tr>
                    <td colspan="2"><input type="submit" value="'._SUBMITCHANGEUSER.'" onclick="editUser();"/> <input type="submit" value="'._CANCELCHANGEUSER.'"/></td>
                  </tr>
                </table>
                <a id="emailpw" href="mailto:'.$pLoginData[5].'?subject='._EMAILUSERNEWPWSUBJECT.'&body='._EMAILUSERNEWPW.'">'._USERNEWPW.'</a><br />
                <a id="email" href="mailto:'.$pLoginData[5].'">'._USEREMAIL.'</a>
                ';
    }

    /**
     * Changes the user information.
     * \return True on success, otherwise false.
     */
    public function editUser()
    {
      $sUserID = isset($_POST['id']) ? $_POST['id'] : '';
      $sFirstName = isset($_POST['firstname']) ? $_POST['firstname'] : '';
      $sLastName = isset($_POST['lastname']) ? $_POST['lastname'] : '';
      $sFieldOfStudy = isset($_POST['fieldofstudy']) ? $_POST['fieldofstudy'] : '';
      $sEmail = isset($_POST['email']) ? $_POST['email'] : '';
      $sPW = isset($_POST['pw']) ? $_POST['pw'] : '';
      
      if (($sUserID == '') ||($sFirstName == '') || ($sLastName == '') || ($sFieldOfStudy == '') || ($sEmail == ''))
      {
        echo "<div class=\"error\">\n"._ERRCHANGINGUSERFAILED."</div>\n";
        return false;
      }
      
      @require('../database/db.inc.php');
      
      //Security (escaping) and encoding handling
      $sUserID = $pDb->escapeString($sUserID);
      $sFirstName = $pDb->escapeString(utf8_decode($sFirstName));
      $sLastName = $pDb->escapeString(utf8_decode($sLastName));
      $sFieldOfStudy = $pDb->escapeString(utf8_decode($sFieldOfStudy));
      $sEmail = $pDb->escapeString($sEmail);
      
      //Change user information
      if(!$pDbCommands->changeUserInfo($pDb, $sUserID, $sFirstName, $sLastName, $sFieldOfStudy))
      {
        return false;
      }
      
      //If a new password is specified, change it
      if ($sPW != '')
      {
        $sPW = sha1($sPW);
        $sPW = $pDb->escapeString($sPW);
        
        if(!$pDbCommands->changeUserPassword($pDb, $sEmail, $sPW))
        {
          return false;
        }
      }
      
      return true;
    }
    
    /**
     * Deletes the specified user.
     * \param $sUserID ID (not e-mail) of the user to delete.
     * \return True on success, otherwise false.
     */
    public function deleteUser($sUserID)
    {
      @require('../database/db.inc.php');
      
      $sUserID = $pDb->escapeString($sUserID);
      
      if(!$pDbCommands->deleteUser($pDb, $sUserID))
      {
        return false;
      }
      
      return true;
    }
    
    /**
     * Deletes the specified users.
     * \param $pUserIDs Array with IDs (not e-mail) of the users to delete.
     * \return True on success, otherwise false.
     */
    public function deleteUsers($pUserIDs)
    {
      while (list($pKey, $sValue) = each($pUserIDs))
      {
        $this->deleteUser($pUserIDs[$pKey]);
      }
    }
    
    /**
     * Resets the database of the specified users.
     * \param $pUserIDs Array of the IDs of the users of those the database has
     *        to be reset.
     * \return True on success, otherwise false.
     */
    public function resetDB($pUserIDs)
    {
      @require('../database/db.inc.php');
      
      //Iterate through users
      while (list($pKey, $sValue) = each($pUserIDs))
      {
        //Get login information of the user
        $pLoginData = $pDbCommands->getLoginDataById($pDb, $pUserIDs[$pKey]);
        
        if(!$pLoginData)
        {
          return false;
        }
        
        //Reset database
        if(!$pDbCommands->createTrainingData($pDb, $pUserIDs[$pKey], $pLoginData[3]))
        {
          return false;
        }
        
        return true;
      }
    }
  }