<?php
  //No direct access
  defined('_ACCESS_') or die('Direct Access to this location is not allowed.');

	/**
	 * <!-- elSQL - e-learn SQL -->
   *
   * \class lostpw
   *
   * Offers functionality for lostpw.php.
   *
   * \author Stephan Schuetz, stephan.schuetz(at)fhnw.ch
   * \date 14.10.2007
   * \version 1.0
   *
   * (c) Copyright GITTA 2007. Creative Commons License "Attribution-Noncommercial-Share Alike"
	 *                           http://creativecommons.org/licenses/by-nc-sa/3.0/
   */
  
  class lostpw
  {
    /**
     * Constructor
     */
    public function __construct()
    {
    }

    /**
     * Destructor
     */
    public function __destruct()
    {
    }
    
    /**
     * Checks values, only the e-mail is validated (correct syntax).
     * \param $sEmail E-mail (=user name) of the user.
     * \return True on success, otherwise false.
     */
    public function checkValues($sEmail)
    {
      $sError = '';
      //E-mail check
      if ($sEmail == '')
      {
        $sError .= _ERREMAIL."<br />\n";
      }
      else if (!ereg("^.+@.+\\..+$", $sEmail))
      {
        $sError .= _ERREMAILVAL."<br />\n";
      }
      
      //On error display message(s)
      if ($sError != '')
      {
        echo "<div class=\"error\">\n".$sError."</div>\n";
        return false;
      }
      
      return true;
    }
    
    /**
     * Sets new password.
     * \param $sEmail E-mail (=user name) of the user.
     * \param $sNewPw New password of the user. If this is an emtpy string, a
     *        password will be generated.
     * \return True on success, otherwise false.
     */
    public function setNewPassword($sEmail, $sNewPw)
    {
      if($sNewPw == '')
      {
        //Password lenght
        $iLength = 10;
        //Allowed figures in new password
        $sFigures = ('abcdefghijklnmopqrstuvwxyzABCDEFGHIJKLNMOPQRSTUVWXYZ0123456789');
        $sNewPw = '';
        //Creates new random password 
        for ($i = 0; $i < $iLength; $i++) 
        {   
          $sNewPw .= $sFigures{mt_rand(0, (strlen($sFigures) - 1))};
        }
      }
      
      $sNewPwSHA = sha1($sNewPw);
      
      @require_once('./database/db.inc.php');
      
      $sEmailEsc = $pDb->escapeString($sEmail);
      $sNewPwSHA = $pDb->escapeString($sNewPwSHA);
      
      //Change password
      if(!$pDbCommands->changeUserPassword($pDb, $sEmailEsc, $sNewPwSHA))
        return false;
      
      //Send password per email to the user (if the server offers this)
      if($pConf['common']['emailsupport'])
      {
        //Create e-mail
        $sSubject = "[elSQL - ".$pConf['info']['title']."]: "._MAILNEWPWSUBJECT;
        $sMessage = _MAILNEWPWMESSAGE.$sNewPw._MAILNEWPWSALUTATION;
        
        $sHeader = "From: elSQL Administrator <".$pConf['info']['email'].">\r\n";
        $sHeader .= "Reply-To:".$pConf['info']['email']."\r\n";
        $sHeader .= "X-Mailer: PHP/".phpversion()."\r\n";
        $sHeader .= "Content-type: text/plain\r\n";
        
        if(!@mail($sEmail, $sSubject, $sMessage, $sHeader))
        {
          echo "<div class=\"error\">\n"._ERREMAILSEND."</div>\n";
          return false;
        }
      }
      
      return true;
    }
  }
?>