<?php

  //No direct access
  defined('_ACCESS_') or die('Direct Access to this location is not allowed.');

	/**
	 * <!-- elSQL - e-learn SQL -->
   *
   * \class newuser
   *
   * Offers functionality for newuser.php.
   *
   * \author Stephan Schuetz, stephan.schuetz(at)fhnw.ch
   * \date 14.10.2007
   * \version 1.0
   *
   * (c) Copyright GITTA 2007. Creative Commons License "Attribution-Noncommercial-Share Alike"
	 *                           http://creativecommons.org/licenses/by-nc-sa/3.0/
   */

  @require_once('./conf/conf.inc.php');

  class newuser
  {
    /**
     * Constructor
     */
    public function __construct()
    {
    }

    /**
     * Destructor
     */
    public function __destruct()
    {
    }
		
    /**
     * Checks values.
     * \param $sFirstName First name of the new user.
     * \param $sLastName Last name of the new user.
     * \param $sFieldOfStudy Field of study of the new user.
     * \param $sEmail E-mail (=user name) of the new user.
     * \param $sRegPw Registration password (to protect site against unallowed registration).
     * \param $sPw Password of the new user.
     * \param $sPwValid Validation of the new password (second input).
     * \return True on success, otherwise false.
     */
    public function checkValues($sFirstName, $sLastName, $sFieldOfStudy, $sEmail, $sRegPw, $sPw, $sPwValid)
    {
      global $pConf;
      
      $sError = '';
			
      //First name check
      if ($sFirstName == '')
      {
        $sError .= _ERRFNAME."<br />\n";
      }
			
      //Last name check
      if ($sLastName == '')
      {
        $sError .= _ERRLNAME."<br />\n";
      }
      
      //Field of study check
      if ($sFieldOfStudy == '')
      {
        $sError .= _ERRFIELDOFSTUDY."<br />\n";
      } 
			
      //E-mail check
      if ($sEmail == '')
      {
        $sError .= _ERREMAIL."<br />\n";
      }
      else if (!ereg("^.+@.+\\..+$", $sEmail))
      {
        $sError .= _ERREMAILVAL."<br />\n";
      }
			
      //Registration password check
      if ($pConf['common']['regpassword'] != '')
      {
        if ($sRegPw != $pConf['common']['regpassword'])
        {
          $sError .= _ERRREGPW."<br />\n";
        }
      }
			
      //Password check
      if ($sPw == '' || $sPwValid == '')
      {
        $sError .= _ERRPWBOTH."<br />\n";
      }
      else if ($sPw != $sPwValid)
      {
        $sError .= _ERRPWVAL."<br />\n";
      }
      else if (strlen ($sPw) < 6)
      {
        $sError .= _ERRPWLENG."<br />\n";
      }
      
      //On error display message(s)
      if ($sError != '')
      {
        echo "<div class=\"error\">\n".$sError."</div>\n";
        
        return false;
      }
			
      return true;
    }
		
    /**
     * Creates a new user account.
     * \param $sFirstName First name of the new user.
     * \param $sLastName Last name of the new user.
     * \param $sFieldOfStudy Field of study of the new user.
     * \param $sEmail E-mail (=user name) of the new user.
     * \param $sPw Password of the new user.
     * \return True on success, otherwise false.
     */
    public function createUserAccount($sFirstName, $sLastName, $sFieldOfStudy, $sEmail, $sPw)
    {
      @require_once('./database/db.inc.php');
      
      $sPw = sha1($sPw);
      
      $sFirstName = $pDb->escapeString(utf8_decode($sFirstName));
      $sLastName = $pDb->escapeString(utf8_decode($sLastName));
      $sFieldOfStudy = $pDb->escapeString(utf8_decode($sFieldOfStudy));
      $sEmail = $pDb->escapeString($sEmail);
      $sPw = $pDb->escapeString($sPw);
      
      return $pDbCommands->createNewUser($pDb, $sFirstName, $sLastName, $sFieldOfStudy, $sEmail, $sPw);
    }
  }
?>