<?php
	//Parent file, set access flag
	define('_ACCESS_', 1);
	
	/**
	 * <!-- elSQL - e-learn SQL -->
   *
   * \par Setup script
   * \file
   *
   * Setup for elSQL. It is really important that you delete this file after
   * setting up elSQL.
   *
   * \author Stephan Schuetz, stephan.schuetz(at)fhnw.ch
   * \date 14.10.2007
   * \version 1.0
   *
   * (c) Copyright GITTA 2007. Creative Commons License "Attribution-Noncommercial-Share Alike"
	 *                           http://creativecommons.org/licenses/by-nc-sa/3.0/
   */
	
	$sDBSystem = isset($_POST['dbsystem']) ? $_POST['dbsystem'] : "";
	$sDBHost = isset($_POST['dbhost']) ? $_POST['dbhost'] : 'localhost';
	$sDBPort = isset($_POST['dbport']) ? $_POST['dbport'] : '';
	$sDBSysUser = isset($_POST['dbsysuser']) ? $_POST['dbsysuser'] : '';
	$sDBSysPw = isset($_POST['dbsyspw']) ? $_POST['dbsyspw'] : '';
	$sDBName = isset($_POST['dbname']) ? $_POST['dbname'] : '';
	$sDBInstance = isset($_POST['dbinstance']) ? mb_strtolower($_POST['dbinstance'], mb_detect_encoding($_POST['dbinstance'])) : '';
	$sDBAdminUser = isset($_POST['dbadminuser']) ? $_POST['dbadminuser'] : '';
	$sDBAdminPw = isset($_POST['dbadminpw']) ? $_POST['dbadminpw'] : '';
	$sDBAdminPwValid = isset($_POST['dbadminpwvalid']) ? $_POST['dbadminpwvalid'] : '';
	$sTitle = isset($_POST['title']) ? $_POST['title'] : '';
	$sEmail = isset($_POST['email']) ? $_POST['email'] : '';
	$sLanguage = isset($_POST['language']) ? $_POST['language'] : '';
	$sDataDir = isset($_POST['datadir']) ? $_POST['datadir'] : '';
	$sMaxNumResults = isset($_POST['maxnumresults']) ? $_POST['maxnumresults'] : 30;
	$bEmailSupport = isset($_POST['emailsupport']) ? $_POST['emailsupport'] : false;
	$sRegPassword = isset($_POST['regpassword']) ? $_POST['regpassword'] : '';
	$bDoIt = isset($_POST['doit']) ? $_POST['doit'] : 0;
?>

<html>
<head>
<title>Setup elSQL</title>
<script type="text/javascript">
<!--
	function setDefaultValues ()
  {
	  if (document.getElementById("dbsystem").value == "pgsql")
	  {
	  	document.getElementById("dbport").value = "5432";
	  	document.getElementById("dbname").value = "template1";
	  	document.getElementById("dbsysuser").value = "postgres";
	  }
	  else if (document.getElementById("dbsystem").value == "mysql")
	  {
	  	document.getElementById("dbport").value = "3306";
	  	document.getElementById("dbname").value = "mysql";
	  	document.getElementById("dbsysuser").value = "root";
	  }
	}
-->
</script>
</head>
<body onload="setDefaultValues()">
<h1>Setup elSQL</h1>
<br />
<form method="POST" action="setup.php">
	<table>
		<tr>
			<td colspan="2">
				  This initialise a database to use for elSQL. Note: The database system must be installed<br />
					properly before you can initialise it.<br />
					To execute the script you need system privilegs. Please enter these login information below.<br />
			</td>
		</tr>
		<tr>
			<td>Select database system:</td>
			<td>
				<select id="dbsystem" name="dbsystem" size="1" onChange="setDefaultValues();">
    			<option <?php ($sDBSystem == 'pgsql') ? (print 'selected="selected"') : (print ''); ?> value="pgsql">PostgreSQL</option>
    			<option <?php ($sDBSystem == 'mysql') ? (print 'selected="selected"') : (print ''); ?> value="mysql">mySQL</option>
    		</select>
			</td>
		</tr>
		<tr>
			<td>Database host:</td>
			<td><input type="text" id="dbhost" name="dbhost" maxlength="30" value="<?php echo $sDBHost; ?>" readonly="readonly"/></td>
		</tr>
		<tr>
			<td>Database port:</td>
			<td><input type="text" id="dbport" name="dbport" maxlength="5" value="<?php echo $sDBPort; ?>"/></td>
		</tr>
		<tr>
			<td>Database name:</td>
			<td><input type="text" id="dbname" name="dbname" maxlength="30" value="<?php echo $sDBName; ?>"/></td>
		</tr>
		<tr>
			<td>Database system user:</td>
			<td><input type="text" id="dbsysuser" name="dbsysuser" maxlength="30" value="<?php echo $sDBSysUser; ?>"/></td>
		</tr>
		<tr>
			<td>Database system password:</td>
			<td><input type="password" id="dbsyspw" name="dbsyspw" maxlength="30" value=""/></td>
		</tr>
		<tr>
			<td colspan="2">
				In this section, you have to specify some attributes of your installation.<br />
				Some of these values could also been edited later in the conf.inc.php file.<br />
			</td>
		</tr>
		<tr>
			<td>Database instance name (only lower case allowed):</td>
			<td><input type="text" id="dbinstance" name="dbinstance" maxlength="30" value="<?php echo $sDBInstance; ?>"/></td>
		</tr>
		<tr>
			<td>elSQL administrator user:</td>
			<td><input type="text" id="dbadminuser" name="dbadminuser" maxlength="16" value="<?php echo $sDBAdminUser; ?>"/></td>
		</tr>
		<tr>
			<td>elSQL administrator password:</td>
			<td><input type="password" id="dbadminpw" name="dbadminpw" maxlength="30" value=""/></td>
		</tr>
		<tr>
			<td>elSQL administrator password validation:</td>
			<td><input type="password" id="dbadminpwvalid" name="dbadminpwvalid" maxlength="30" value=""/></td>
		</tr>
		<tr>
			<td>University name:</td>
			<td><input type="text" id="title" name="title" maxlength="30" value="<?php echo $sTitle; ?>"/></td>
		</tr>
		<tr>
			<td>E-mail administrator:</td>
			<td><input type="text" id="email" name="email" maxlength="30" value="<?php echo $sEmail; ?>"/></td>
		</tr>
		<tr>
			<td>Select frontend language:</td>
			<td>
				<select id="language" name="language" size="1">
    			<option <?php ($sLanguage == 'en') ? (print 'selected="selected"') : (print ''); ?> >en</option>
    			<option <?php ($sLanguage == 'de') ? (print 'selected="selected"') : (print ''); ?> >de</option>
    		</select>
			</td>
		</tr>
		<tr>
			<td>Select data:</td>
			<td>
				<select id="datadir" name="datadir" size="1">
					<?php
						$pDataDirs = scandir('../data');

						foreach ($pDataDirs as $sDir)
						{
							if(is_dir('../data/'.$sDir) && $sDir != '.' && $sDir != '..')
							{
								echo '<option '.(($sDataDir == $sDir) ? 'selected="selected"' : '').' >'.$sDir.'</option>';
							}
						}
					?>
    		</select>
			</td>
		</tr>
		<tr>
			<td>Maximum number of shown results:</td>
			<td><input type="text" id="maxnumresults" name="maxnumresults" maxlength="30" value="<?php echo $sMaxNumResults; ?>"/></td>
		</tr>
		<tr>
			<td>E-mail sending available (depends on server configuration):</td>
			<td>
				<select id="emailsupport" name="emailsupport" size="1">
    			<option value="false" selected="selected">No</option>
    			<option value="true">Yes</option>
    		</select>
    	</td>
		</tr>
		<tr>
			<td>Registration password:</td>
			<td><input type="text" id="regpassword" name="regpassword" maxlength="30" value="<?php echo $sRegPassword; ?>"/></td>
		</tr>
	</table>
	<input type="hidden" name="doit" value="1"/>
	<input type="submit" value="Initialise DB"/>
</form>
<?php
	if ($bDoIt)
	{
		//Check values
		if ($sDBHost == '' || $sDBPort == '' ||	$sDBName == '' || $sDBSysUser == '' || $sDBSysPw == '' ||
		    $sDBInstance == '' || $sDBAdminUser == '' || $sDBAdminPw == '' || $sDBAdminPwValid == '' ||
		    $sTitle == '' || $sEmail == '' || $sMaxNumResults == '' || $sLanguage == '')
		{
			echo '<div class="error">Except of the registration password all of the fields above must be filled, so please check.</div>';
		}
		//Validate new administrator password
		else if ($sDBAdminPw != $sDBAdminPwValid)
		{
			echo '<div class="error">elSQL administrator passwords do not match, please re-type.</div>';
		}
		else
		{
			//PostgreSQL database
			if ($sDBSystem == 'pgsql')
			{
				require('../database/pgsql.class.php');
				
				$pDb = new pgsql();
				
				$sSetupScript = "CREATE DATABASE ".$sDBInstance." WITH ENCODING='UTF8';";
				
				if (!$pDb->connectDB($sDBHost, $sDBPort, $sDBName, $sDBSysUser, $sDBSysPw))
				{
					echo '<div class="error">Database connection failed, please check specified values.</div>';
					return;
				}
				
				if (!$pDb->executeSQL($sSetupScript))
				{
					echo '<div class="error">Database creation failed: '.$pDb->getLastError().'</div>';
					return;
				}
				
				$pDb->closeDB();
				
				$sSetupScript = "BEGIN;
				                 CREATE ROLE ".$sDBAdminUser."_group NOINHERIT CREATEDB CREATEROLE VALID UNTIL 'infinity';
				                 CREATE ROLE ".$sDBAdminUser." LOGIN PASSWORD '".$sDBAdminPw."' INHERIT CREATEDB CREATEROLE VALID UNTIL 'infinity' IN ROLE ".$sDBAdminUser."_group;
				                 CREATE SCHEMA \"admin\" AUTHORIZATION \"".$sDBAdminUser."\";
				                 CREATE TABLE \"admin\".\"users\"(id BIGSERIAL, lastname TEXT, firstname TEXT, email CHARACTER VARYING(100), fieldofstudy TEXT, password CHARACTER VARYING(40), lastlogin DATE, PRIMARY KEY (id), UNIQUE (email)) WITH OIDS;
				                 ALTER TABLE \"admin\".\"users\" OWNER TO \"".$sDBAdminUser."\";
				                 GRANT ALL ON DATABASE ".$sDBInstance." TO GROUP ".$sDBAdminUser."_group WITH GRANT OPTION;
				                 DROP SCHEMA public CASCADE;
				                 COMMIT;";
				
				if (!$pDb->connectDB($sDBHost, $sDBPort, $sDBInstance, $sDBSysUser, $sDBSysPw))
				{
					echo '<div class="error">Database connection failed: '.$pDb->getLastError().'<br/>Please check specified values.</div>';
					return;
				}
				
				if (!$pDb->executeSQL($sSetupScript))
				{
					echo '<div class="error"> Setting up database failed: '.$pDb->getLastError().'</div>';
					return;
				}
			}
			//mySQL database
			else if ($sDBSystem == 'mysql')
			{
				require('../database/mysql.class.php');
				
				$pDb = new mysql();
				
				if (!$pDb->connectDB($sDBHost, $sDBPort, $sDBName, $sDBSysUser, $sDBSysPw))
				{
					echo $pDb->getLastError();
					echo '<div class="error">Database connection failed: '.$pDb->getLastError().'<br/>Please check specified values.</div>';
					return;
				}
				
				if (!$pDb->executeSQL("CREATE DATABASE ".$sDBInstance." DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;"))
				{
					echo '<div class="error"> Setting up database failed: '.$pDb->getLastError().'</div>';
					return;
				}
				
				$pDb->closeDB();
				
				if (!$pDb->connectDB($sDBHost, $sDBPort, $sDBInstance, $sDBSysUser, $sDBSysPw))
				{
					echo $pDb->getLastError();
					echo '<div class="error">Database connection failed: '.$pDb->getLastError().'<br/>Please check specified values.</div>';
					return;
				}
				
				if (!$pDb->executeSQL("CREATE USER '".$sDBAdminUser."'@'localhost' IDENTIFIED BY '".$sDBAdminPw."'") ||
				    !$pDb->executeSQL("GRANT ALL PRIVILEGES ON *.* TO '".$sDBAdminUser."'@'localhost' WITH GRANT OPTION MAX_QUERIES_PER_HOUR 0 MAX_CONNECTIONS_PER_HOUR 0 MAX_UPDATES_PER_HOUR 0 MAX_USER_CONNECTIONS 0") ||
				    !$pDb->executeSQL("GRANT SELECT , INSERT , UPDATE , DELETE , CREATE , DROP , ALTER ON ".$sDBInstance.".* TO '".$sDBAdminUser."'@'localhost'") ||
				    !$pDb->executeSQL("CREATE TABLE ".$sDBInstance.".users (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY,lastname TEXT NULL,firstname TEXT NULL,email VARCHAR(100) NOT NULL,fieldofstudy TEXT NULL,password VARCHAR(40) NULL,lastlogin DATE, UNIQUE (email)) ENGINE = innodb") ||
				    !$pDb->executeSQL("GRANT SELECT , INSERT , UPDATE , DELETE , CREATE , DROP , REFERENCES , INDEX , ALTER , CREATE VIEW , SHOW VIEW ON ".$sDBInstance.".users TO '".$sDBAdminUser."'@'localhost' WITH GRANT OPTION"))
				{
					echo '<div class="error"> Setting up database failed: '.$pDb->getLastError().'</div>';
					return;
				}
			}
      
			//Writing configuration file
			require('../common/common.inc.php');
      
      if (!writeConfig($sDBSystem, $sDBHost, $sDBPort, $sDBInstance, $sDBAdminUser, $sDBAdminPw, $sLanguage, $sDataDir, $sRegPassword, $sMaxNumResults, $bEmailSupport, $sTitle, $sEmail, true))
      {
        	echo '<div class="error"> Configuration file could not be written, check access permissions (web server user).</div>';
					return;
      }
			
			echo '<div class="success">Setup successfully finished!<br/><br/>
			      Important note: It is really important that you now delete this setup file (setup.php).<br/>
			      If you do not do this this will be a security vulnerability of your installation.</div>';
		}
	}
?>
</body>
</html>