<?php
  //No direct access
  defined('_ACCESS_') or die('Direct Access to this location is not allowed.');

  /**
	 * <!-- elSQL - e-learn SQL -->
   *
   * \par Oracle setup script for "default" data set
   * \file
   *
   * Sets up the "default" data set for Oracle databases. Before the data is
   * set up, the old data will be dropped.
   *
   * \author Stephan Schuetz, stephan.schuetz(at)fhnw.ch
   * \date 14.10.2007
   * \version 1.0
   *
   * (c) Copyright GITTA 2007. Creative Commons License "Attribution-Noncommercial-Share Alike"
	 *                           http://creativecommons.org/licenses/by-nc-sa/3.0/
   */

  $pDataSetup[0] = "DROP TABLE \"arbeitet_an\"";
  $pDataSetup[1] = "DROP TABLE \"angehoeriger\"";
  $pDataSetup[2] = "DROP TABLE \"projekt\"";
  $pDataSetup[3] = "DROP TABLE \"abt_ort\"";
  $pDataSetup[4] = "ALTER TABLE \"angestellter\" DROP CONSTRAINT \"fk_ang_abtnr\"";
  $pDataSetup[5] = "ALTER TABLE \"abteilung\" DROP CONSTRAINT \"fk_abt_ahvnr\"";
  $pDataSetup[6] = "DROP TABLE \"angestellter\"";
  $pDataSetup[7] = "DROP TABLE \"abteilung\"";

  $pDataSetup[8] = "CREATE TABLE abteilung(AName CHAR(20), ANummer NUMBER PRIMARY KEY, Leiter NUMBER, Anfdatum DATE)";
  $pDataSetup[9] = "CREATE TABLE angestellter (VName CHAR(30), NName CHAR(30), AHVNr NUMBER PRIMARY KEY, Gebtag DATE, Adresse CHAR(30), Geschlecht CHAR(1), Salaer NUMBER, Vorges NUMBER, Abt NUMBER, CONSTRAINT fk_ang_vorgnr FOREIGN KEY (Vorges) REFERENCES angestellter(AHVNr), CONSTRAINT fk_ang_abtnr FOREIGN KEY (Abt) REFERENCES abteilung(ANummer))";
  $pDataSetup[10] = "ALTER TABLE abteilung ADD CONSTRAINT fk_abt_ahvnr FOREIGN KEY (Leiter) REFERENCES angestellter(AHVNr)";
  $pDataSetup[11] = "CREATE TABLE abt_ort(ANummer NUMBER NOT NULL, AOrt CHAR(30), CONSTRAINT pk_abtort PRIMARY KEY (ANummer, AOrt), CONSTRAINT fk_abtort_abtnummer FOREIGN KEY (ANummer) REFERENCES abteilung(ANummer))";
  $pDataSetup[12] = "CREATE TABLE projekt(PName CHAR(20), PNummer NUMBER PRIMARY KEY, POrt CHAR(30), Abt NUMBER, CONSTRAINT fk_projekt_abtnr FOREIGN KEY (Abt) REFERENCES abteilung(ANummer))";
  $pDataSetup[13] = "CREATE TABLE angehoeriger(Ang NUMBER, Name CHAR(30), Geschlecht CHAR(1), Gebtag DATE, Verwgrad CHAR(15), CONSTRAINT pk_angeh PRIMARY KEY(Ang, Name), CONSTRAINT fk_angeh_ang FOREIGN KEY (Ang) REFERENCES angestellter(AHVNr))";
  $pDataSetup[14] = "CREATE TABLE arbeitet_an(Ang NUMBER, Projekt NUMBER, Stunden NUMBER, CONSTRAINT pk_arbeitetan PRIMARY KEY (Ang, Projekt), CONSTRAINT fk_arb_AHV FOREIGN KEY (Ang) REFERENCES angestellter(AHVNr), CONSTRAINT fk_arb_ProjNr FOREIGN KEY (Projekt) REFERENCES projekt(PNummer))";

  $pDataSetup[15] = "INSERT INTO abteilung (AName, ANummer, Anfdatum) VALUES ('Forschung', 5, {d '1988-05-22'})";
  $pDataSetup[16] = "INSERT INTO abteilung (AName, ANummer, Anfdatum) VALUES ('Verwaltung', 4, {d '1985-01-01'})";
  $pDataSetup[17] = "INSERT INTO abteilung (AName, ANummer, Anfdatum) VALUES ('Management', 1, {d '1981-06-19'})";
  $pDataSetup[18] = "INSERT INTO angestellter (VName, NName, AHVNr, Gebtag, Adresse, Geschlecht, Salaer, Abt) VALUES ('Mirella', 'Freni', 6608, {d '1938-06-22'}, 'Duebendorf', 'w', 55000,1)";
  $pDataSetup[19] = "INSERT INTO angestellter (VName, NName, AHVNr, Gebtag, Adresse, Geschlecht, Salaer, Vorges, Abt) VALUES ('Beate', 'Tell', 8635, {d '1965-01-14'}, 'Kuesnacht', 'w', 40000, 6608, 5)";
  $pDataSetup[20] = "INSERT INTO angestellter (VName, NName, AHVNr, Gebtag, Adresse, Geschlecht, Salaer, Vorges, Abt) VALUES ('Boris', 'Frisch', 9260, {d '1945-06-03'}, 'Zug', 'm', 43000, 6608, 4)";
  $pDataSetup[21] = "INSERT INTO angestellter (VName, NName, AHVNr, Gebtag, Adresse, Geschlecht, Salaer, Vorges, Abt) VALUES ('Kurt', 'Huesli', 5908, {d '1950-12-30'}, 'Zuerich', 'm', 30000, 8635, 5)";
  $pDataSetup[22] = "INSERT INTO angestellter (VName, NName, AHVNr, Gebtag, Adresse, Geschlecht, Salaer, Vorges, Abt) VALUES ('Sonja', 'Maradona', 7639, {d '1955-11-11'}, 'Bern', 'w', 38000, 8635, 5)";
  $pDataSetup[23] = "INSERT INTO angestellter (VName, NName, AHVNr, Gebtag, Adresse, Geschlecht, Salaer, Vorges, Abt) VALUES ('Guiseppe', 'Wagner', 2938, {d '1939-03-04'}, 'Zuerich', 'm', 25000, 8635, 5)";
  $pDataSetup[24] = "INSERT INTO angestellter (VName, NName, AHVNr, Gebtag, Adresse, Geschlecht, Salaer, Vorges, Abt) VALUES ('Ruedi', 'Becker', 6736, {d '1959-12-24'}, 'Wallisellen', 'm', 25000, 9260, 4)";
  $pDataSetup[25] = "INSERT INTO angestellter (VName, NName, AHVNr, Gebtag, Adresse, Geschlecht, Salaer, Vorges, Abt) VALUES ('Amando', 'Verdi', 4077, {d '1952-08-19'}, 'Duebendorf', 'm', 25000, 9260, 4)";
  $pDataSetup[26] = "UPDATE abteilung SET Leiter = 8635 WHERE ANummer = 5";
  $pDataSetup[27] = "UPDATE abteilung SET Leiter = 9260 WHERE ANummer = 4";
  $pDataSetup[28] = "UPDATE abteilung SET Leiter = 6608 WHERE ANummer = 1";
  $pDataSetup[29] = "INSERT INTO abt_ort VALUES (1, 'Kloten')";
  $pDataSetup[30] = "INSERT INTO abt_ort VALUES (4, 'Zuerich')";
  $pDataSetup[31] = "INSERT INTO abt_ort VALUES (5, 'Zug')";
  $pDataSetup[32] = "INSERT INTO abt_ort VALUES (5, 'Baden')";
  $pDataSetup[33] = "INSERT INTO abt_ort VALUES (5, 'Kloten')";
  $pDataSetup[34] = "INSERT INTO projekt VALUES ('ProduktX', 1,  'Zug', 5)";
  $pDataSetup[35] = "INSERT INTO projekt VALUES ('ProduktY', 2, 'Baden', 5)";
  $pDataSetup[36] = "INSERT INTO projekt VALUES ('Produkt Z', 3,  'Kloten', 5)";
  $pDataSetup[37] = "INSERT INTO projekt VALUES ('Informatik', 10, 'Zuerich', 4)";
  $pDataSetup[38] = "INSERT INTO projekt VALUES ('Reorganisation', 20, 'Kloten', 1)";
  $pDataSetup[39] = "INSERT INTO projekt VALUES ('Soziales', 30, 'Zuerich', 4)";
  $pDataSetup[40] = "INSERT INTO angehoeriger VALUES (8635, 'Alice', 'w', {d '1986-04-05'}, 'Tochter')";
  $pDataSetup[41] = "INSERT INTO angehoeriger VALUES (8635, 'Max', 'm', {d '1988-10-25'}, 'Sohn')";
  $pDataSetup[42] = "INSERT INTO angehoeriger VALUES (8635, 'Ueli', 'm', {d '1963-05-03'}, 'Ehemann')";
  $pDataSetup[43] = "INSERT INTO angehoeriger VALUES (9260,'Greti', 'w', {d '1946-02-28'}, 'Ehefrau')";
  $pDataSetup[44] = "INSERT INTO angehoeriger VALUES (5908, 'Beat', 'm', {d '1978-01-01'}, 'Sohn')";
  $pDataSetup[45] = "INSERT INTO angehoeriger VALUES (5908, 'Alice', 'w', {d '1978-12-31'}, 'Tochter')";
  $pDataSetup[46] = "INSERT INTO angehoeriger VALUES (5908, 'Liesli', 'w', {d '1957-05-05'}, 'Ehefrau')";
  $pDataSetup[47] = "INSERT INTO arbeitet_an VALUES (5908, 1, 32.5)";
  $pDataSetup[48] = "INSERT INTO arbeitet_an VALUES (5908, 2, 7.5)";
  $pDataSetup[49] = "INSERT INTO arbeitet_an VALUES (7639, 3, 40.0)";
  $pDataSetup[50] = "INSERT INTO arbeitet_an VALUES (2938, 1, 20.0)";
  $pDataSetup[51] = "INSERT INTO arbeitet_an VALUES (2938, 2, 20.0)";
  $pDataSetup[52] = "INSERT INTO arbeitet_an VALUES (8635, 2, 10.0)";
  $pDataSetup[53] = "INSERT INTO arbeitet_an VALUES (8635, 3, 10.0)";
  $pDataSetup[54] = "INSERT INTO arbeitet_an VALUES (8635, 20, 10.0)";
  $pDataSetup[55] = "INSERT INTO arbeitet_an VALUES (6736, 30, 30.0)";
  $pDataSetup[56] = "INSERT INTO arbeitet_an VALUES (6736, 10, 10.0)";
  $pDataSetup[57] = "INSERT INTO arbeitet_an VALUES (4077, 10, 35.0)";
  $pDataSetup[58] = "INSERT INTO arbeitet_an VALUES (4077, 30, 5.0)";
  $pDataSetup[59] = "INSERT INTO arbeitet_an VALUES (9260, 30, 20.0)";
  $pDataSetup[60] = "INSERT INTO arbeitet_an VALUES (9260, 20, 15.0)";
  $pDataSetup[61] = "INSERT INTO arbeitet_an (Ang, Projekt) VALUES (6608, 20)";
?>