<?php
  //No direct access
  defined('_ACCESS_') or die('Direct Access to this location is not allowed.');

  /**
	 * <!-- elSQL - e-learn SQL -->
   *
   * \par Database handler
   * \file
   *
   * Include this file to select the database backend which
   * is defined in configuration file and creates such a database 
   * object named pDB and a database commands object named $pDbCommands.
   *
   * \author Stephan Schuetz, stephan.schuetz(at)fhnw.ch
   * \date 14.10.2007
   * \version 1.0
   *
   * (c) Copyright GITTA 2007. Creative Commons License "Attribution-Noncommercial-Share Alike"
	 *                           http://creativecommons.org/licenses/by-nc-sa/3.0/
   */
  
  @require_once(dirname(__FILE__).'/../conf/conf.inc.php');

  global $pConf;
  
	//PostgreSQL database
  if ($pConf['database']['system'] == 'pgsql')
  {
    require_once(dirname(__FILE__).'/../database/pgsql.class.php');
    $pDb = new pgsql();
    
    require_once(dirname(__FILE__).'/../database/pgsqlcommands.class.php');
    $pDbCommands = new pgsqlcommands();
  }
	//mySQL database
  else if ($pConf['database']['system'] == 'mysql')
  {
    require_once(dirname(__FILE__).'/../database/mysql.class.php');
    $pDb = new mysql();
    
    require_once(dirname(__FILE__).'/../database/mysqlcommands.class.php');
    $pDbCommands = new mysqlcommands();
  }
?>