<?php
  //No direct access
  defined('_ACCESS_') or die('Direct Access to this location is not allowed.');

  /**
	 * <!-- elSQL - e-learn SQL -->
   *
   * \class mysqlcommands
   *
   * mySQL commands handler.
   *
   * \author Stephan Schuetz, stephan.schuetz(at)fhnw.ch
   * \date 14.10.2007
   * \version 1.0
   *
   * (c) Copyright GITTA 2007. Creative Commons License "Attribution-Noncommercial-Share Alike"
	 *                           http://creativecommons.org/licenses/by-nc-sa/3.0/
   */

  global $pDataSetup;
  
  @require_once(dirname(__FILE__).'/../conf/conf.inc.php');
  @require_once(dirname(__FILE__).'/../language/language.inc.php');
  @require_once(dirname(__FILE__).'/../common/common.inc.php');
  @require_once(dirname(__FILE__).'/../data/'.$pConf['common']['datadir'].'/data_mysql.php');
  @require_once(dirname(__FILE__).'/idatabasecommands.class.php');
  
  class mysqlcommands implements iDatabaseCommands
  {
    /**
     * Creates a new user.
     * \param $pDb Pointer to database connection.
     * \param $sFirstName First name of new user.
     * \param $sLastName Last name of new user.
     * \param $sFieldOfStudy Field of study of the new user.
     * \param $sEmail E-mail address of the new user.
     * \param $sPw Password of the new user.
     * \return True on success, otherwise false.
     */
    public function createNewUser($pDb, $sFirstName, $sLastName, $sFieldOfStudy, $sEmail, $sPw)
    {
      global $pConf;
      
      //Add new user to user administration table
      $pDb->connectDBAdmin();
      
      $sSQL[0] = "INSERT INTO ".$pConf['database']['name'].".users (lastname, firstname, email, fieldofstudy, password) VALUES ('".$sLastName."','".$sFirstName."','".$sEmail."','".$sFieldOfStudy."','".$sPw."')";
      
      if(!$pDb->executeSQL($sSQL[0]))
      {
        echo "<div class=\"error\">\n"._ERRCREATEUSER." Code: 11</div>\n";
        $pDb->closeDB();
        return false;
      }
      
      //Get ID of the new user
      $sSQL[0] = "SELECT id FROM ".$pConf['database']['name'].".users WHERE email LIKE '".$sEmail."'";
      
      if(!$pDb->executeSQL($sSQL[0]))
      {
        echo "<div class=\"error\">\n"._ERRCREATEUSER." Code: 12</div>\n";
        $pDb->closeDB();
        return false;
      }
      
      $pDb->getNextRecord();
      
      $sUserID = $pDb->getNextField();
      
      //Create environment
      $sSQL[0] = "CREATE USER '".$sUserID."'@'localhost' IDENTIFIED BY '".$sPw."'";
      $sSQL[1] = "CREATE DATABASE ".$pConf['database']['name']."_".$sUserID." COLLATE utf8_general_ci";
      $sSQL[2] = "GRANT ALL PRIVILEGES ON ".$pConf['database']['name']."_".$sUserID.".* TO '".$pConf['database']['user']."'@'localhost' WITH GRANT OPTION";
      $sSQL[3] = "GRANT USAGE ON *.* TO '".$sUserID."'@'localhost' IDENTIFIED BY '".$sPw."' WITH MAX_QUERIES_PER_HOUR 0 MAX_CONNECTIONS_PER_HOUR 0 MAX_UPDATES_PER_HOUR 0 MAX_USER_CONNECTIONS 0";
      $sSQL[4] = "GRANT ALL PRIVILEGES ON ".$pConf['database']['name']."_".$sUserID.".* TO '".$sUserID."'@'localhost'";
      $sSQL[5] = "FLUSH PRIVILEGES";
      
      if(!$pDb->executeTransaction($sSQL))
      {
        echo "<div class=\"error\">\n"._ERRCREATEUSER." Code: 13</div>\n";
        $pDb->closeDB();
        return false;
      }
      
      $pDb->closeDB();
      
      //Create data
      return $this->createTrainingData($pDb, $sUserID, $sPw);
    }
    
    /**
     * Delete a user.
     * \param $pDb Pointer to database connection.
     * \param $sUserID ID of the user to delete.
     * \return True on success, otherwise false.
     */
    public function deleteUser($pDb, $sUserID)
    {
			global $pConf;
			
			$pDb->connectDBAdmin();
      
			//Drop user and all his data
			$sSQL[0] = "DELETE FROM ".$pConf['database']['name'].".users WHERE id=".$sUserID;
			$sSQL[1] = "REVOKE GRANT OPTION ON ".$pConf['database']['name']."_".$sUserID." . * FROM '".$pConf['database']['user']."'@'localhost'";
      $sSQL[2] = "REVOKE ALL PRIVILEGES ON ".$pConf['database']['name']."_".$sUserID." . * FROM '".$pConf['database']['user']."'@'localhost'";
      $sSQL[3] = "DROP DATABASE ".$pConf['database']['name']."_".$sUserID;
      $sSQL[4] = "DROP USER '".$sUserID."'@'localhost'";
      
			if(!$pDb->executeTransaction($sSQL))
      {
        echo "<div class=\"error\">\n"._ERRDROPUSER."</div>\n";
        $pDb->closeDB();
        return false;
      }
      
			$pDb->closeDB();
      return true;
    }
    
		/**
     * Change user password.
     * \param $pDb Pointer to database connection.
     * \param $sUserEmail E-mail address of the user which wants to change his
     *        password.
     * \param $sNewPw New password.
     * \return True on success, otherwise false.
     */
    public function changeUserPassword($pDb, $sUserEmail, $sNewPw)
    {
      global $pConf;
      
      $pDb->connectDBAdmin();
      
      //Check if there is such a user
      $sSQL[0] = "SELECT COUNT(*) FROM ".$pConf['database']['name'].".users WHERE email LIKE '".$sUserEmail."'";
      $pDb->executeSQL($sSQL[0]);
      
      $pDb->getNextRecord();
      
      if($pDb->getNextField() == 0)
      {
        echo "<div class=\"error\">\n"._ERRMAILUNKOWN."</div>\n";
        $pDb->closeDB();
        return false;
      }
      
      //Get user ID
      $sSQL[0] = "SELECT id FROM ".$pConf['database']['name'].".users WHERE email LIKE '".$sUserEmail."'";
      
      if(!$pDb->executeSQL($sSQL[0]))
      {
        echo "<div class=\"error\">\n"._ERRCHANGEPW." Code: 14</div>\n";
        $pDb->closeDB();
        return false;
      }
      
      $pDb->getNextRecord();
      
      $sUserID = $pDb->getNextField();
      
      //Change password
      $sSQL[0] = "SET PASSWORD FOR '".$sUserID."'@'localhost' = PASSWORD( '".$sNewPw."' )";
      $sSQL[1] = "UPDATE ".$pConf['database']['name'].".users SET password='".$sNewPw."' WHERE id='".$sUserID."'";
      
      if(!$pDb->executeTransaction($sSQL))
      {
        echo "<div class=\"error\">\n"._ERRCHANGEPW." Code: 15</div>\n";
        $pDb->closeDB();
        return false;
      }
      
      $pDb->closeDB();
      
      return true;
    }
    
    /**
     * Change administrator password.
     * \param $pDb Pointer to database connection.
     * \param $sAdminName Name of the administrator user.
     * \param $sNewPw New password.
     * \return True on success, otherwise false.
     */
    public function changeAdminPassword($pDb, $sAdminName, $sNewPw)
    {
			$pDb->connectDBAdmin();
      
      $sSQL[0] = "SET PASSWORD FOR '".$sAdminName."'@'localhost' = PASSWORD( '$sNewPw' )";
			
			if(!$pDb->executeSQL($sSQL[0]))
      {
        echo "<div class=\"error\">\n"._ERRCHANGEADMINPW." Code: 16</div>\n";
        $pDb->closeDB();
        return false;
      }
      
			$pDb->closeDB();
			
      return true;
    }
    
		/**
     * Creates training data or resets user database to initial values.
     * \param $pDb Pointer to database connection.
     * \param $sUserID User ID.
     * \param $sPw Password.
     * \return True on success, otherwise false.
     */
    public function createTrainingData($pDb, $sUserID, $sPw)
    {
      global $pDataSetup;
      
      $pDb->connectDBUser($sUserID, $sPw);
      
      //Get all existing tables
      $sSQL = 'SHOW TABLES';
      
      if(!$pDb->executeSQL($sSQL))
      {
        echo "<div class=\"error\">\n"._ERRCREATETRAININGDATA."</div>\n";
        
        $pDb->closeDB();
        return false;
			}
      
      //If there are existing tables, drop them
      if ($pDb->getNumberRows() >= 1)
      {
        $pSQL = Array();
        $i = 0;
        
        while($pDb->getNextRecord())
        {
          $pSQL[$i] = 'DROP TABLE IF EXISTS `'.$pDb->getNextField().'`';
          $i++;
        }
        
        if(!$pDb->executeTransaction($pSQL))
        {
          echo "<div class=\"error\">\n"._ERRCREATETRAININGDATA."</div>\n";
          
          $pDb->closeDB();
          return false;
        }
      }
      
      //Init database
      if(!$pDb->executeTransaction($pDataSetup))
      {
        echo "<div class=\"error\">\n"._ERRCREATETRAININGDATA."</div>\n";
        $pDb->closeDB();
        return false;
      }      
      $pDb->closeDB();
      
      return true;
    }
    
		/**
     * Get login data by user name (e-mail address).
     * \param $pDb Pointer to database connection.
     * \param $sUserName User name (e-mail address).
     * \return Array with login data (0: User ID, 1: Last name, 2: First name,
     *         3: Password, 4: Field of study, 5: E-mail address) on success,
     *         otherwise false.
     */
    public function getLoginData($pDb, $sUserName)
    {
      global $pConf;
      
      $pDb->connectDBAdmin();
      
      $sSQL = "SELECT id, lastname, firstname, password, fieldofstudy, email FROM ".$pConf['database']['name'].".users WHERE email LIKE '".$sUserName."'";
      
      if(!$pDb->executeSQL($sSQL))
      {
        echo "<div class=\"error\">\n"._ERRLOGINFAILED."</div>\n";
        $pDb->closeDB();
        return false;
      }
      
      if(!$pDb->getNextRecord())
      {
        echo "<div class=\"error\">\n"._ERRLOGINFAILED."</div>\n";
        $pDb->closeDB();
        return false;
      }
      
      $pLoginData = array();
      $pLoginData[0] = $pDb->getNextField();
      $pLoginData[1] = $pDb->getNextField();
      $pLoginData[2] = $pDb->getNextField();
      $pLoginData[3] = $pDb->getNextField();
      $pLoginData[4] = $pDb->getNextField();
      $pLoginData[5] = $pDb->getNextField();
      
      $pDb->closeDB();
      
      return $pLoginData; 
    }
    
		/**
     * Get login data by user ID.
     * \param $pDb Pointer to database connection.
     * \param $sUserID User ID.
     * \return Array with login data (0: User ID, 1: Last name, 2: First name,
     *         3: Password, 4: Field of study, 5: E-mail address) on success,
     *         otherwise false.
     */
    public function getLoginDataById($pDb, $sUserID)
    {
      global $pConf;
      
      $pDb->connectDBAdmin();
      
      $sSQL = "SELECT id, lastname, firstname, password, fieldofstudy, email FROM ".$pConf['database']['name'].".users WHERE id LIKE '".$sUserID."'";
      
      if(!$pDb->executeSQL($sSQL))
      {
        echo "<div class=\"error\">\n"._ERRLOGINFAILED."</div>\n";
        $pDb->closeDB();
        return false;
      }
      
      if(!$pDb->getNextRecord())
      {
        echo "<div class=\"error\">\n"._ERRLOGINFAILED."</div>\n";
        $pDb->closeDB();
        return false;
      }
      
      $pLoginData = array();
      $pLoginData[0] = $pDb->getNextField();
      $pLoginData[1] = $pDb->getNextField();
      $pLoginData[2] = $pDb->getNextField();
      $pLoginData[3] = $pDb->getNextField();
      $pLoginData[4] = $pDb->getNextField();
      $pLoginData[5] = $pDb->getNextField();
      
      $pDb->closeDB();
      
      return $pLoginData;
    }
    
 		/**
     * Set login date (format Y-M-D, e.g. 2007-10-14) of user (actual date used,
     * according to server date).
     * \param $pDb Pointer to database connection.
     * \param $sUserName E-mail address of the user.
     */
    public function setLastLoginDate($pDb, $sUserName)
    {
      global $pConf;
      
      $pDb->connectDBAdmin();
      $sSQL = "UPDATE ".$pConf['database']['name'].".users SET lastlogin='".date("Y-m-d")."' WHERE email LIKE '".$sUserName."'";
      $pDb->executeSQL($sSQL);
      
      $pDb->closeDB(); 
    }
    
 		/**
     * Reset all user databases.
     * \param $pDb Pointer to database connection.
     * \return True on success, otherwise false.
     */
		public function resetAllUserDb($pDb)
		{
			global $pConf;
      
      $pDb->connectDBAdmin();
      
      //Get user IDs and passwords
      $sSQL = "SELECT id, password FROM ".$pConf['database']['name'].".users";
			
			if(!$pDb->executeSQL($sSQL))
			{
				echo "<div class=\"error\">\n"._ERRRESETALLDB."</div>\n";
        $pDb->closeDB();
        return false;
			}
			
      //Iterate through result set, reset the user databases
			while($pDb->getNextRecord())
      {
				$sUserID = $pDb->getNextField();
				$sUserPW = $pDb->getNextField();
				$pDb->hasMoreFields();
				
				if(!$this->createTrainingData(new mysql(), $sUserID, $sUserPW))
				{
					echo "<div class=\"error\">\n"._ERRRESETALLDB."</div>\n";
					$pDb->closeDB();
					return false;
				}
      }
			
			$pDb->closeDB();
			
			return true;
		}
    
 		/**
     * Build table for user administration.
     * \param $pDb Pointer to database connection.
     * \return True on success, otherwise false.
     */
    public function buildUserTable($pDb)
    {
      global $pConf;
      
      $pDb->connectDBAdmin();
      
      //Get user information
      $sSQL = "SELECT id, lastname, firstname, email, fieldofstudy, lastlogin FROM ".$pConf['database']['name'].".users ORDER BY lastname ASC, firstname ASC";
      
      if(!$pDb->executeSQL($sSQL))
      {
				echo "<div class=\"error\">\n"._ERRCREATEUSERTABLE."</div>\n";
        $pDb->closeDB();
        return false;
			}
      
      //Get user out of result set, build table
      while($pDb->getNextRecord())
      {
        $sID = $pDb->getNextField();
        $sLastName = utf8_encode($pDb->getNextField());
        $sFirstName = utf8_encode($pDb->getNextField());
        $sEmail = $pDb->getNextField();
        $sFieldOfStudy = utf8_encode($pDb->getNextField());
        $sLastLogin = $pDb->getNextField();
        $pDb->hasMoreFields();
        
        echoUserTable($sID, $sLastName, $sFirstName, $sFieldOfStudy, $sEmail, $sLastLogin);
      }
      
      $pDb->closeDB();
      
      return true;
    }
    
		/**
     * Change user information.
     * \param $pDb Pointer to database connection.
     * \param $sUserID User ID.
     * \param $sFirstName New first name.
     * \param $sLastName New last name.
     * \param $sFieldOfStudy New field of study.
     * \return True on success, otherwise false.
     */
    public function changeUserInfo($pDb, $sUserID, $sFirstName, $sLastName, $sFieldOfStudy)
    {
      global $pConf;
      
      $pDb->connectDBAdmin();
      
      $sSQL = "UPDATE ".$pConf['database']['name'].".users SET lastname='".$sLastName."', firstname='".$sFirstName."', fieldofstudy='".$sFieldOfStudy."' WHERE id=".$sUserID;
      
      if(!$pDb->executeSQL($sSQL))
      {
        echo "<div class=\"error\">\n"._ERRCHANGINGUSERFAILED."</div>\n";
        
        $pDb->closeDB();
        return false;
			}
      
      $pDb->closeDB();
      
      return true;
    }
    
    /**
     * Builds table which shows the actual data in the database.
     * \param $pDb Pointer to database connection.
     * \param $sUserID User ID.
     * \param $sPw Password.
     * \return True on success, otherwise false.
     */    
    public function showActualDataUserDB($pDb, $sUserID, $sPw)
    {
      $pDb->connectDBUser($sUserID, $sPw);
      
      $sSQL = 'SHOW TABLES';
      
      if(!$pDb->executeSQL($sSQL))
      {
        echo "<div class=\"error\">\n"._ERRSHOWDATAUSERDB."</div>\n";
        
        $pDb->closeDB();
        return false;
			}
      
      $sTableNamesArray = Array();
      $i = 0;
      
      while($pDb->getNextRecord())
      {
        $sTableNamesArray[$i] = $pDb->getNextField();
        $i++;
      }
      
      foreach ($sTableNamesArray as $sTableName)
      {
        $sSQL = 'SELECT * FROM `'.$sTableName.'`';
        
        if(!$pDb->executeSQL($sSQL))
        {
          echo "<div class=\"error\">\n"._ERRSHOWDATAUSERDB."</div>\n";
          
          $pDb->closeDB();
          return false;
  			}
        
        echo "<h3 class=\"desc\">".$sTableName."</h3>\n";
        echo "<table class=\"desc\">\n";
        echo "<tr>\n";
        
        //Show field description
        while($pDb->hasMoreFields())
        {
          $pTemp = $pDb->getNextFieldDescription();
          
          echo "<th class=\"desc\">".trim($pTemp[0])."</th>\n";
        }
        
        echo "</tr>\n";
        
        //Show data
        while($pDb->getNextRecord())
        {
          echo  "<tr>\n";
          
          while($pDb->hasMoreFields())
          {
            echo "<td class=\"desc\">".trim($pDb->getNextField())."</td>\n";
          }
          
          echo "</tr>\n";
        }
        
        echo "</table>\n";
      }
    }
  }
?>