<?php  
  //No direct access
  defined('_ACCESS_') or die('Direct Access to this location is not allowed.');
  
	/**
	 * <!-- elSQL - e-learn SQL -->
   *
   * \class layout
   *
   * Offers some basic layout functions like printing header and footer. E-mail
   * cloaking (spam protection) is also implemented.
   *
   * \author Stephan Schuetz, stephan.schuetz(at)fhnw.ch
   * \date 14.10.2007
   * \version 1.0
   *
   * (c) Copyright GITTA 2007. Creative Commons License "Attribution-Noncommercial-Share Alike"
	 *                           http://creativecommons.org/licenses/by-nc-sa/3.0/
   */
	
  class layout
  {
		/**
     * Returns the HTML code for the title in the head section.
     * \param $additionalTitle Needed to expand the title, by default ''.
     * \return Echo HTML code.
     */
    public function printTitle($additionalTitle = '')
    {
      global $pConf;
			
      if ($additionalTitle != '')
      {
        echo '<title>'.$additionalTitle.' - elSQL '.$pConf['info']['title'].'</title>';
      }
      else
      {
        echo '<title>elSQL '.$pConf['info']['title'].'</title>';
      }
    }
		
		/**
     * Returns the HTML code for the footer, which contains the administrator
     * e-mail, the license information and the version.
     * \return Echo HTML code.
     */
    public function printFooter()
    {
      global $pConf;
			
      echo '<div class="footer">
              <div class="email">';
      echo $this->cloakingEmail($pConf['info']['email'], _CONTACTADMIN)."\n";
      echo '  </div>
              <div class="version">
                elSQL Version '.$pConf['internal']['version'].'<br /><a href="http://creativecommons.org/licenses/by-nc-sa/3.0/" target="_blank">&copy; GITTA 2007 (Creative Commons)</a>
              </div>
            </div>
						';
    }
		
		/**
     * Returns the spam protected e-mail address.
     * \param $sEmail E-mail address to protect.
     * \param $sText Name of the link.
     * \return Echo HTML code.
     */
    private function cloakingEmail($sEmail, $sText)
    {
      $sEmail = str_replace('a', '&#97;', $sEmail);
      $sEmail = str_replace('e', '&#101;', $sEmail);
      $sEmail = str_replace('i', '&#105;', $sEmail);
      $sEmail = str_replace('o', '&#111;', $sEmail);
      $sEmail = str_replace('u', '&#117;', $sEmail);
			
      //Split e-mail (separator @)
      $pEmail = explode('@', $sEmail);
      $pMailParts = explode('.', $pEmail[1]);
      
      //Create random number
      $iRand = rand(1, 100000);
			
			//Create javascript which protects e-mail address
      $sReplacement = "<script language='JavaScript' type='text/javascript'>\n";
      $sReplacement .= "<!--\n";
      $sReplacement .= "var sPrefix = '&#109;a' + 'i&#108;' + '&#116;o';\n";
      $sReplacement .= "var sPath = 'hr' + 'ef' + '=';\n";
      $sReplacement .= "var sAddy".$iRand." = '".$pEmail[0] ."' + '&#64;';\n";
      $sReplacement .= "sAddy".$iRand." = sAddy".$iRand." + '".implode("' + '&#46;' + '", $pMailParts)."';\n";
      $sReplacement .= "var sAddyText".$iRand." = '".$sText."';\n";
      $sReplacement .= "document.write('<a ' + sPath + '\'' + sPrefix + ':' + sAddy".$iRand." + '\'>');\n";
      $sReplacement .= "document.write(sAddyText".$iRand.");\n";
      $sReplacement .= "document.write('<\/a>');\n";
      $sReplacement .= "//-->\n";
      $sReplacement .= "</script>";
      
      //Handling case if javascript is not enabled
      $sReplacement .= "<script language='JavaScript' type='text/javascript'>\n";
      $sReplacement .= "<!--\n";
      $sReplacement .= "document.write('<span style=\'display: none;\'>');\n";
      $sReplacement .= "//-->\n";
      $sReplacement .= "</script>\n";
      $sReplacement .= _EMAILCLOAKING."\n";
      $sReplacement .= "<script language='JavaScript' type='text/javascript'>\n";
      $sReplacement .= "<!--\n";
      $sReplacement .= "document.write('</');\n";
      $sReplacement .= "document.write('span>');\n";
      $sReplacement .= "//-->\n";
      $sReplacement .= "</script>";
			
      return $sReplacement;
    }
  }
?>