<?php
  //Parent file, set access flag
  define('_ACCESS_', 1);
  
  /**
	 * <!-- elSQL - e-learn SQL -->
	 * 
   * \par Lost password site/from
   * \file
   *
   * Shows information on how to get a new password. If the webserver is able 
   * to send e-mails, a form is shown which enables the user to specify his
   * e-mail to which the server sends a new password.
   *
   * \author Stephan Schuetz, stephan.schuetz(at)fhnw.ch
   * \date 14.10.2007
   * \version 1.0
   *
   * (c) Copyright GITTA 2007. Creative Commons License "Attribution-Noncommercial-Share Alike"
	 *                           http://creativecommons.org/licenses/by-nc-sa/3.0/
   */

  @require_once('./conf/conf.inc.php');
  @require_once('./layout/layout.inc.php');
  @require_once('./language/language.inc.php');

  @require('./common/lostpw.class.php');

  $sEmail = '';
  
  $bValuesReceived = false;

  if (isset($_POST['email']))
  {
    $sEmail = $_POST['email'];
    $bValuesReceived = true;
  }
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
<link rel="stylesheet" type="text/css" href="./layout/global.css"/>
<?php $pLayout->printTitle(_LOSTPWTITLE); ?>
</head>
<body>
<h1><?php echo _LOSTPWTITLE ?></h1>
<br />
<?php 

  //Check if e-mail support is available on this server
  if($pConf['common']['emailsupport'])
  {
		//Start output buffer
    ob_start();
    
    echo '<form method="post" action="lostpw.php">
            <table>
              <tr>
                <td colspan="2">'._LOSTPWINFOSERVER.'</td>
              </tr>
              <tr>
                <td>'._EMAIL.'</td>
                <td><input type="text" name="email" maxlength="30" value="'.$sEmail.'"/></td>
              </tr>
            </table>
            <input type="submit" value="'._SUBMIT.'"/>
          </form>
          ';
    
    //Check if values are received, -> perform the password change
    if($bValuesReceived)
    {
      $pLostPw = new lostpw();
  
      if($pLostPw->checkValues($sEmail))
      {
        if($pLostPw->setNewPassword($sEmail, ''))
        {
					//Clean output buffer
          ob_end_clean();
					//Change location
          header('Location: index.php');
        }
      }
    }
    
		//Flush output buffer
    ob_end_flush();
  }
  else
  {
    echo '<table>
            <tr>
              <td>'._LOSTPWINFOADMIN.'</td>
            </tr>
            <tr>
              <td><a href="index.php">'._BACKTOLOGIN.'</a></td>
            </tr>
          </table><br />
    ';
  }
  
  $pLayout->printFooter();
?>
</body>
</html>