<?php
  //Parent file, set access flag
  define('_ACCESS_', 1);
	
	/**
	 * <!-- elSQL - e-learn SQL -->
	 * 
   * \par New user form
   * \file
   *
   * Form to subscribe as a new user.
   *
   * \author Stephan Schuetz, stephan.schuetz(at)fhnw.ch
   * \date 14.10.2007
   * \version 1.0
   *
   * (c) Copyright GITTA 2007. Creative Commons License "Attribution-Noncommercial-Share Alike"
	 *                           http://creativecommons.org/licenses/by-nc-sa/3.0/
   */

  @require_once('./layout/layout.inc.php');
  @require_once('./language/language.inc.php');

  @require('./common/newuser.class.php');

  $sFirstName = '';
  $sLastName = '';
  $sFieldOfStudy = '';
  $sEmail = '';
  $sRegPw = '';
  $sPw = '';
  $sPwValid = '';
  
  $bValuesReceived = false;

  if (isset($_POST['firstname']))
  {
    $sFirstName = $_POST['firstname'];
    $bValuesReceived = true;
  }
  if (isset($_POST['lastname']))
  {
    $sLastName = $_POST['lastname'];
    $bValuesReceived = true;
  }
  if (isset($_POST['fieldofstudy']))
  {
    $sFieldOfStudy = $_POST['fieldofstudy'];
    $bValuesReceived = true;
  }
  if (isset($_POST['email']))
  {
    $sEmail = $_POST['email'];
    $bValuesReceived = true;
  }
  if (isset($_POST['regpw']))
  {
    $sRegPw = $_POST['regpw'];
    $bValuesReceived = true;
  }
  if (isset($_POST['pw']))
  {
    $sPw = $_POST['pw'];
    $bValuesReceived = true;
  }
  if (isset($_POST['pwvalid']))
  {
    $sPwValid = $_POST['pwvalid'];
    $bValuesReceived = true;
  }
	
  //Start output buffer
  ob_start();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
<link rel="stylesheet" type="text/css" href="./layout/global.css"/>
<?php $pLayout->printTitle(_USERREGTITLE); ?>
</head>
<body>
<h1><?php echo _USERREGTITLE ?></h1>
<br />
<form method="post" action="newuser.php">
  <?php echo _USERREGINFO; ?>
  <table>
    <tr>
      <td><?php echo _FNAME; ?></td>
      <td><input type="text" name="firstname" maxlength="30" value="<?php echo $sFirstName; ?>"/></td>
    </tr>
    <tr>
      <td><?php echo _LNAME; ?></td>
      <td><input type="text" name="lastname" maxlength="30" value="<?php echo $sLastName; ?>"/></td>
    </tr>
    <tr>
      <td><?php echo _FIELDOFSTUDY; ?></td>
      <td><input type="text" name="fieldofstudy" maxlength="30" value="<?php echo $sFieldOfStudy; ?>"/></td>
    </tr>
    <tr>
      <td><?php echo _EMAIL; ?></td>
      <td><input type="text" name="email" maxlength="30" value="<?php echo $sEmail; ?>"/></td>
    </tr>
    <?php
      if($pConf['common']['regpassword'] != "")
      {
        echo '<tr>
              <td>'._REGPASSWORD.'</td>
              <td><input type="text" name="regpw" maxlength="30" value="'.$sRegPw.'"/></td>
              </tr>
							';
      }
    ?>
    <tr>
      <td><?php echo _PASSWORD; ?></td>
      <td><input type="password" name="pw" maxlength="30"/></td>
    </tr>
    <tr>
      <td><?php echo _PASSWORDVALID; ?></td>
      <td><input type="password" name="pwvalid" maxlength="30"/></td>
    </tr>
  </table>
  <input type="submit" value="<?php echo _REGISTER; ?>"/>
</form>
<?php
	//Check if values are received
  if($bValuesReceived)
  {
    $pNewUser = new newuser();
		
		//Check values and create new user, forward to login page
    if($pNewUser->checkValues($sFirstName, $sLastName, $sFieldOfStudy, $sEmail, $sRegPw, $sPw, $sPwValid))
    {
      if($pNewUser->createUserAccount($sFirstName, $sLastName, $sFieldOfStudy, $sEmail, $sPw))
      {
			  //Clean output buffer
			  ob_end_clean();
			  //Change location
				header('Location: index.php?user='.$sEmail.'&');
			}
    }
  }
	
  $pLayout->printFooter();
	
	//Flush output buffer
  ob_end_flush();
?>
</body>
</html>