<?php
  //Parent file, set access flag
  define('_ACCESS_', 1);
	
	/**
	 * <!-- elSQL - e-learn SQL -->
	 * 
   * \par Handler for SQL requests
   * \file
   *
   * Processes the SQL statements of the user.
   *
   * Returns JSON encoded data (array containing the elements: res, log and sql).
   *
   * \author Stephan Schuetz, stephan.schuetz(at)fhnw.ch
   * \date 14.10.2007
   * \version 1.0
   *
   * (c) Copyright GITTA 2007. Creative Commons License "Attribution-Noncommercial-Share Alike"
	 *                           http://creativecommons.org/licenses/by-nc-sa/3.0/
   */
  
  session_start();
  
  if(!isset($_SESSION['s_sUserID']))
    die('Login required.');

  @require_once('./conf/conf.inc.php');
  @require_once('./language/language.inc.php');

  @require('./common/sqlresult.class.php');

  $sSQL = isset($_POST['sql']) ? stripslashes(trim($_POST['sql'])) : '';
  $bLog = isset($_POST['log']) ? $_POST['log'] : false;
  $bShowAll = isset($_POST['all']) ? $_POST['all'] : false;

  if ($sSQL == '')
  {
    echo "<div class=\"error\">"._ERRNOQUERY."</div>\n";
  }
  else
  {
    $pSqlResult = new sqlresult();
    
    $pReturn = $pSqlResult->showResult($sSQL, $_SESSION['s_sUserID'], $_SESSION['s_sPw'], $bLog, $bShowAll);
    
    $pReturn['sql'] = $pSqlResult->formatStatement($sSQL);
    
    echo json_encode($pReturn);
  }
?>