<?php
  //Parent file, set access flag
  define('_ACCESS_', 1);
  
  /**
	 * <!-- elSQL - e-learn SQL -->
	 * 
   * \par Main user working site
   * \file
   *
   * Main site of elSQL. Enables the user to work with the database, create and
   * print a log, change his settings and resetting his database to the initial
   * data set. 
   *
   * \author Stephan Schuetz, stephan.schuetz(at)fhnw.ch
   * \date 14.10.2007
   * \version 1.0
   *
   * (c) Copyright GITTA 2007. Creative Commons License "Attribution-Noncommercial-Share Alike"
	 *                           http://creativecommons.org/licenses/by-nc-sa/3.0/
   */
  
  session_start();
  
  if(!isset($_SESSION['s_sUserID']))
    die('Login required.');
  

  @require_once('./conf/conf.inc.php');
  @require_once('./layout/layout.inc.php');
  @require_once('./language/language.inc.php');
  
  if (isset($_GET['logout']))
  {
    session_unset();
    session_destroy();

    header('Location: index.php');
  }
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
<link rel="stylesheet" type="text/css" href="./layout/global.css"/>
<link rel="stylesheet" type="text/css" href="./layout/work.css"/>
<script type="text/javascript" src="./lib/dojo/dojo.js"></script>
<script type="text/javascript">
<!--
  dojo.require("dojo.widget.TabContainer");
  dojo.require("dojo.widget.LinkPane");
  dojo.require("dojo.widget.ContentPane");
  dojo.require("dojo.io.*");
  dojo.require("dojo.json");
  
  function init()
  {
    new dojo.io.FormBind({
        formNode: document.forms.formSQL,
        load: handlerFormSQL});
    
    new dojo.io.FormBind({
        formNode: document.forms.formChangeUser,
        load: handlerFormStdReturn});
    
    new dojo.io.FormBind({
        formNode: document.forms.formChangePW,
        load: handlerFormStdReturn});

    var pFormResetDB = new dojo.io.FormBind({
        formNode: document.forms.formResetDB,
        load: handlerFormStdReturn});
    
    pFormResetDB.onSubmit = handlerFormResetDBSubmit;

    setAll();
    setLog();
  }
  
  function handlerFormSQL(type, data, e)
  {
    var pData = dojo.json.evalJson(data);
    dojo.byId("workStatement").innerHTML = pData['sql'];
    dojo.byId("workResult").innerHTML = pData['res'];
    if (pData['log'] != null)
    {
      <?php
        if (preg_match('|MSIE|',$_SERVER['HTTP_USER_AGENT']))
        {
          echo "dojo.byId(\"workLog\").innerText = dojo.byId(\"workLog\").innerText + pData['log'];\n";
        }
        else
        {
          echo "dojo.byId(\"workLog\").innerHTML = dojo.byId(\"workLog\").innerHTML + pData['log'];\n";
        }
      ?>
    }
  }
  
  function handlerFormStdReturn(type, data, e)
  {
    var pData = dojo.json.evalJson(data);
    if (pData['ret'] == true)
    {
      alert(pData['mes']);
    }
    else
    {
      alert(pData['mes']);
    }
  }
  
  function handlerFormResetDBSubmit()
  {
    return confirm("<?php echo _RESETDBCONFIRMATION; ?>");
  }
  
  function setAll()
  {
    if(dojo.byId("selectAll").checked == true)
    {
      dojo.byId("all").value = 1;
    }
    else
    {
      dojo.byId("all").value = 0;
    }
  }
  
  function setLog()
  {
    if(dojo.byId("selectLog").checked == true)
    {
      dojo.byId("log").value = 1;
    }
    else
    {
      dojo.byId("log").value = 0;
    }
  }
  
  function printLog()
  {
    sPrintLog = "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\"><html><head><meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\"/><title>elSQL <?php echo _LOG; ?></title><link rel=\"stylesheet\" type=\"text/css\" href=\"./layout/printlog.css\" /></head><body><div class=\"workLogPrint\"><pre>" + dojo.byId("workLog").innerHTML + "</pre></div></body></html>";
    var pLogWindow = window.open('about:blank','_blank','width=800,height=600,resizable=yes,menubar=yes,status=yes');
    pLogWindow.document.open();
    pLogWindow.document.write(sPrintLog);
    pLogWindow.document.close();
    
    pLogWindow.print();
  }
  
  function clearLog()
  {
    dojo.byId("workLog").innerHTML = "";
  }
  
  dojo.addOnLoad(init);
-->
</script>
<?php $pLayout->printTitle(_WORKTITLE); ?>
</head>
<body>
<div class="logout"><?php echo utf8_encode($_SESSION['s_sFirstName'].' '.$_SESSION['s_sLastName']); ?> <a href="work.php?logout=true&"><?php echo _LOGOUT ?></a></div>
<h1><?php echo 'elSQL - '.$pConf['info']['title'].'<br />'._WORKTITLE ?></h1>
<div id="mainTabContainer" dojoType="TabContainer" selectedTab="tab1" style="width: 100%; height: 83%;">

  <div id="tab1" dojoType="ContentPane" label="<?php echo _WORK; ?>" style="overflow:auto;">
    <div class="insideTab">
      <form method="post" action="sqlresult.php" id="formSQL">
        <table>
          <tr>
            <td><?php echo _SQLQUERY; ?></td>
            <td><textarea name="sql" cols="50" rows="10"></textarea></td>
          </tr>
        </table>
        <input type="hidden" value="0" name="log" id="log"/>
        <input type="hidden" value="0" name="all" id="all"/>
        <input type="submit" value="<?php echo _SENDQUERY; ?>"/>
      </form>
      <h3><?php echo _SUBSTATEMENT; ?></h3>
      <div id="workStatement" class="workStatement"></div>
      <h3><?php echo _RESULT; ?></h3>
      <div id="workResult"></div>
    </div>
  </div>

  <div id="tab2" dojoType="ContentPane" label="<?php echo _DATASET; ?>">
    <div class="insideTab">
      <div id="subTabContainer" dojoType="TabContainer" selectedTab="subtab1" style="width: 100%; height: 98%;">
        
        <div id="subtab1" class="insideTab" label="<?php echo _SHOWORIDATA; ?>" dojoType="LinkPane" href="./data/<?php echo $pConf['common']['datadir']; ?>/description.php" style="overflow:auto; height: 98%;"></div>
        
        <div id="subtab2" class="insideTab" label="<?php echo _SHOWACTDATA; ?>" dojoType="LinkPane" cacheContent="false" executeScripts="true" refreshOnShow="true" href="./data/dynamicdata.php" style="overflow:auto; height: 98%;"></div>
        
      </div>
    </div>
  </div>

  <div id="tab3" dojoType="ContentPane" label="<?php echo _LOG; ?>">
    <div class="insideTab">
      <div dojoType="LayoutContainer">
        <div dojoType="ContentPane">
          <button id="printLogButton" onclick="printLog();"><?php echo _PRINTLOG; ?></button> <button id="clearLogButton" onclick="clearLog();"><?php echo _CLEARLOG; ?></button>
        </div>
        <div dojoType="ContentPane" style="overflow:auto; height:96%">
          <div id="workLog" class="workLog"></div>
        </div>
      </div>
    </div>
  </div>

  <div id="tab4" dojoType="ContentPane" label="<?php echo _SETTINGS; ?>" style="overflow:auto;">
    <div class="insideTab">
      <h3><?php echo _ENVIRONMENT; ?></h3>
      <input type="checkbox" id="selectLog" onclick="setLog();" checked="checked"/>&nbsp;&nbsp;<?php echo _CREATELOG; ?><br />
      <input type="checkbox" id="selectAll" onclick="setAll();"/>&nbsp;&nbsp;<?php echo _SHOWALL; ?><br />
      <br />
      <h3><?php echo _CHANGEUSERINFO; ?></h3>
      <form method="post" action="common.php" id="formChangeUser">
        <input type="hidden" value="uuic" name="act"/>
        <table>
          <tr>
            <td colspan="2"><?php echo _CHANGEUSEREXPLANATION; ?></td>
          </tr>
          <tr>
            <td><?php echo _FNAME; ?></td>
            <td><input type="text" name="firstname" maxlength="30" value="<?php echo utf8_encode($_SESSION['s_sFirstName']); ?>"/></td>
          </tr>
          <tr>
            <td><?php echo _LNAME; ?></td>
            <td><input type="text" name="lastname" maxlength="30" value="<?php echo utf8_encode($_SESSION['s_sLastName']); ?>"/></td>
          </tr>
          <tr>
            <td><?php echo _FIELDOFSTUDY; ?></td>
            <td><input type="text" name="fieldofstudy" maxlength="30" value="<?php echo utf8_encode($_SESSION['s_sFieldOfStudy']); ?>"/></td>
          </tr>
          <tr>
            <td><?php echo _EMAIL; ?></td>
            <td><input type="text" name="email" maxlength="30" value="<?php echo $_SESSION['s_sEmail']; ?>" readonly="readonly"/></td>
          </tr>
          <tr>
            <td colspan="2"><input type="submit" value="<?php echo _CHANGEUSER; ?>"/></td>
          </tr>
        </table>
      </form>
      <br />
      <h3><?php echo _CHANGEPASSWORD; ?></h3>
      <form method="post" action="common.php" id="formChangePW">
        <input type="hidden" value="upwc" name="act"/>
        <table>
          <tr>
            <td><?php echo _OLDPASSWORD; ?></td>
            <td><input type="password" name="opw" maxlength="30"/></td>
          </tr>
          <tr>
            <td><?php echo _NEWPASSWORD; ?></td>
            <td><input type="password" name="npw" maxlength="30"/></td>
          </tr>
          <tr>
            <td><?php echo _NEWPASSWORD2; ?></td>
            <td><input type="password" name="npwv" maxlength="30"/></td>
          </tr>
          <tr>
            <td colspan="2"><input type="submit" value="<?php echo _CHANGEPW; ?>"/></td>
          </tr>
        </table>
      </form>
      <br />
      <h3><?php echo _RESETDB; ?></h3>
      <form method="post" action="common.php" id="formResetDB">
      <input type="hidden" value="urdb" name="act"/>
        <table>
          <tr>
            <td><?php echo _RESETDBEXPLANATION; ?></td>
          </tr>
          <tr>
            <td><input type="submit" value="<?php echo _RESETDB; ?>"/></td>
          </tr>
        </table>
      </form>
    </div>
  </div>

  <div id="tab5" dojoType="ContentPane" label="<?php echo _INFORMATION; ?>">
    <div class="insideTab">
    <?php
      echo _LICENSE;
      $pLayout->printFooter();
    ?>
    </div>
  </div>
</div>
</body>
</html>
<?php
  session_write_close();
?>